// Code generated by templ - DO NOT EDIT.

// templ: version: 0.2.476
package web

//lint:file-ignore SA4006 This context is only used if a nested component is present.

import "github.com/a-h/templ"
import "context"
import "io"
import "bytes"

func aggrid() templ.ComponentScript {
	return templ.ComponentScript{
		Name: `__templ_aggrid_2ef3`,
		Function: `function __templ_aggrid_2ef3(){// Specify the columns
var columnDefs = [
    {headerName: "Make", field: "make", filter: true},
    {headerName: "Model", field: "model", filter: true},
    {headerName: "Price", field: "price", filter: true,
        cellRenderer: 'agAnimateShowChangeCellRenderer'
    }
];

var rowData = [
    {make: "Toyota", model: "Celica", price: 35000},
    {make: "Ford", model: "Mondeo", price: 32000},
    {make: "Porsche", model: "Boxster", price: 72000},
    {make: "BMW", model: "5 Series", price: 45000},
    {make: "Tesla", model: "Model S", price: 70000},
    {make: "Honda", model: "Civic", price: 20000}
];

        // Updated grid creation to use createGrid
        var gridOptions = {
            columnDefs: columnDefs,
            rowData: rowData,
        enableSorting: true,
        enableFilter: true,
          getRowId: (params) => {
    return params.data.model;
  },
        };

        // Setup the grid after the page has finished loading
            const eGridDiv = document.querySelector('#myGrid');
    var gridApi = agGrid.createGrid(eGridDiv, gridOptions);
const ws = new WebSocket(` + "`" + `${location.protocol === 'https:' ? 'wss' : 'ws'}://${location.host}/ws` + "`" + `);


ws.onmessage = (event) => {
    const newData = JSON.parse(event.data);
console.log(newData);

rowToUpdate = rowData.find((row) => row.model === newData.model)
rowToUpdate.price = newData.price;
    gridApi.applyTransactionAsync({update: [newData]});
};
  window.addEventListener('close_aggrid_ws', function(event) {
    console.log('divRemoved');
    ws.close(1000, 'divRemoved');
    console.log('connection closed');
  });}`,
		Call:       templ.SafeScript(`__templ_aggrid_2ef3`),
		CallInline: templ.SafeScriptInline(`__templ_aggrid_2ef3`),
	}
}

func AgGrid() templ.Component {
	return templ.ComponentFunc(func(ctx context.Context, templ_7745c5c3_W io.Writer) (templ_7745c5c3_Err error) {
		templ_7745c5c3_Buffer, templ_7745c5c3_IsBuffer := templ_7745c5c3_W.(*bytes.Buffer)
		if !templ_7745c5c3_IsBuffer {
			templ_7745c5c3_Buffer = templ.GetBuffer()
			defer templ.ReleaseBuffer(templ_7745c5c3_Buffer)
		}
		ctx = templ.InitializeContext(ctx)
		templ_7745c5c3_Var1 := templ.GetChildren(ctx)
		if templ_7745c5c3_Var1 == nil {
			templ_7745c5c3_Var1 = templ.NopComponent
		}
		ctx = templ.ClearChildren(ctx)
		_, templ_7745c5c3_Err = templ_7745c5c3_Buffer.WriteString("<h1>")
		if templ_7745c5c3_Err != nil {
			return templ_7745c5c3_Err
		}
		templ_7745c5c3_Var2 := `Simple AG Grid Example`
		_, templ_7745c5c3_Err = templ_7745c5c3_Buffer.WriteString(templ_7745c5c3_Var2)
		if templ_7745c5c3_Err != nil {
			return templ_7745c5c3_Err
		}
		_, templ_7745c5c3_Err = templ_7745c5c3_Buffer.WriteString("</h1><div _=\"on htmx:beforeSwap from the closest parent &lt;div/&gt; send close_aggrid_ws\" id=\"myGrid\" style=\"height: 600px; width:100%;\" class=\"ag-theme-quartz-dark\"></div>")
		if templ_7745c5c3_Err != nil {
			return templ_7745c5c3_Err
		}
		templ_7745c5c3_Err = aggrid().Render(ctx, templ_7745c5c3_Buffer)
		if templ_7745c5c3_Err != nil {
			return templ_7745c5c3_Err
		}
		if !templ_7745c5c3_IsBuffer {
			_, templ_7745c5c3_Err = templ_7745c5c3_Buffer.WriteTo(templ_7745c5c3_W)
		}
		return templ_7745c5c3_Err
	})
}
